//////////////////////////////////////////////////////////////////////////////////
// Dieses Programm speichert alle Elemente auf Layer 9 und 10 in eine			//
// DXF-Datei mit gleichen Namen wie die Ursprungszeichnung 						// 
// 																				//
// Version 0.1																	//
// (C) 2011.09.21																//
// JonCarpenter																	//
// Lizenz: GPL																	//
//////////////////////////////////////////////////////////////////////////////////

#pragma HeapMin 50000
#pragma HeapMax 100000
/**********************************************************************/
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
/**********************************************************************/

char edta[32000];// Puffer für variable Daten

// löscht alle Elemente außer auf Layer 9 und 10
short DelEntity(void *argptr )
{
	t_entity  *ent;
	ent =(t_entity  *) argptr;

	//Prüfen, ob NICHT  Layer 9 oder 10 ist
	if( !((ent->attr.lay == 9) || (ent->attr.lay == 10)) )
	{
		//Element löschen
		if(DeleteEntity(ent->id)) return(CONTINUE_LOOP); // | CALL_SAVECOUNT);
	}
	return(CONTINUE_LOOP);
}

short main(char *filename, char *args)
{
	char buf[256];
	char file[513];
	t_entity ent;
	t_mat44  ecs;
	
	// Selektionskriterium (0xffffffff) -> alle Elemente erlaubt
	// Schleife über alle Elemente und aufruf von DelEntity
	EntityLoop(0xffffffff,0xffffffff,DelEntity,&ent,edta,sizeof(edta),&ecs);
	savecount(); // Änderungen in Undo-Liste eintragen

	// aktuellen Filenamen ermitteln
	if( !GetCurrentFile(file) )
	{
		// kein Name
		sprintf(file, "default.dxf");
	}
	else
	{
		// Endung entfernen
		sprintf((file+strlen(file)-4), ".dxf");
	}
	// Kommandostring zum speichern zusammenstellen
	sprintf(buf, "%s%s", "PrtSavAs ", file);
	// MegaCAD Kommando ausführen
	MegaCMD(buf);
	
	// MegaCAD Kommando ausführen (gelöschte Elemente wieder herstellen und Autozoom)
	MegaCMD("Undo");
	MegaCMD("AZoomAll");
	// Zeichnung als unverändet markieren (Keine Speicherdialog)
	ResetSavecount();
	
	switch(Message("Elemente wurden gespeichert unter:", file, NULL, "Oeffnen", "Weiter",3))
	{
		case 2: // Kommandostring zum öffnen zusammenstellen
				sprintf(buf, "%s%s", "PrtLoad ", file);
				// MegaCAD Kommando ausführen
				MegaCMD(buf);
	}
	
	//Programm beenden
	return(0);
}
/**********************************************************************/